<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelProdutosVendidoNormalPromo  {

    protected $RelProdutosVendidoNormalPromoService;
    protected $utilService;
    
    public function __construct(Services\RelProdutosVendidoNormalPromoService $RelProdutosVendidoNormalPromoService, Utilities\Util $utilService) {
        $this->RelProdutosVendidoNormalPromoService = $RelProdutosVendidoNormalPromoService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);

        $conditions = $this->buildParamsFaturamento($conditions);
        $result = $this->RelProdutosVendidoNormalPromoService->find($conditions['CDFILIAL'], $conditions['NRORG'], $conditions['CDLOJA'], $conditions['TCDLOJA'], $conditions['DTVENDAINI'], $conditions['DTVENDAFIN'], $conditions['CDPRODLIST'], $conditions ['CDARVPRODI'], $conditions['CDARVPRODF'], $conditions['PRODNIV'], $conditions['TCDPRODUTO'], $conditions['GRUPLOJA']);
        $response->addDataSet(new DataSet("vnd0160b_relProdVendidoNormPromo", $result));
        
        return $response;
    }
    
    
    public function buildParamsFaturamento($conditions){
        $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        $conditions['TCDPRODUTO'] = 'T';
       
        if(!array_key_exists('CDARVPRODI', $conditions)) {
            
            $conditions['CDARVPRODI'] = null;
        }

        if(!array_key_exists('CDARVPRODF', $conditions)) {
            $conditions['CDARVPRODF'] = null;
        }
        
        if(!array_key_exists('CDLOJA', $conditions)) {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        } else {
            $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $conditions['TCDLOJA'] = '';
        }
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DTVENDAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTVENDAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        
         if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
          }
          $conditions['CDARVPRODI'] = str_replace("%", "",$conditions['CDARVPRODI']);
          $conditions['CDARVPRODF'] = str_replace("%", "",$conditions['CDARVPRODF']);
          $conditions["CDARVPRODF"]=str_pad($conditions["CDARVPRODF"], 15, 'z');
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
            
           
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
         
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
          
        } 
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        
        }
     
        return $conditions;   
        
    }
   
}